<?php

namespace App\Lib\Unifaun\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConsignmentTemplatesResult StructType
 * @subpackage Structs
 */
class ConsignmentTemplatesResult extends AbstractStructBase
{
    /**
     * The consignmentTemplate
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App\Lib\Unifaun\StructType\ConsignmentTemplate[]
     */
    public $consignmentTemplate;
    /**
     * The errors
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App\Lib\Unifaun\StructType\Error[]
     */
    public $errors;
    /**
     * Constructor method for ConsignmentTemplatesResult
     * @uses ConsignmentTemplatesResult::setConsignmentTemplate()
     * @uses ConsignmentTemplatesResult::setErrors()
     * @param \App\Lib\Unifaun\StructType\ConsignmentTemplate[] $consignmentTemplate
     * @param \App\Lib\Unifaun\StructType\Error[] $errors
     */
    public function __construct(array $consignmentTemplate = array(), array $errors = array())
    {
        $this
            ->setConsignmentTemplate($consignmentTemplate)
            ->setErrors($errors);
    }
    /**
     * Get consignmentTemplate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App\Lib\Unifaun\StructType\ConsignmentTemplate[]|null
     */
    public function getConsignmentTemplate()
    {
        return isset($this->consignmentTemplate) ? $this->consignmentTemplate : null;
    }
    /**
     * This method is responsible for validating the values passed to the setConsignmentTemplate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setConsignmentTemplate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateConsignmentTemplateForArrayConstraintsFromSetConsignmentTemplate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $consignmentTemplatesResultConsignmentTemplateItem) {
            // validation for constraint: itemType
            if (!$consignmentTemplatesResultConsignmentTemplateItem instanceof \App\Lib\Unifaun\StructType\ConsignmentTemplate) {
                $invalidValues[] = is_object($consignmentTemplatesResultConsignmentTemplateItem) ? get_class($consignmentTemplatesResultConsignmentTemplateItem) : sprintf('%s(%s)', gettype($consignmentTemplatesResultConsignmentTemplateItem), var_export($consignmentTemplatesResultConsignmentTemplateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The consignmentTemplate property can only contain items of type \App\Lib\Unifaun\StructType\ConsignmentTemplate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set consignmentTemplate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App\Lib\Unifaun\StructType\ConsignmentTemplate[] $consignmentTemplate
     * @return \App\Lib\Unifaun\StructType\ConsignmentTemplatesResult
     */
    public function setConsignmentTemplate(array $consignmentTemplate = array())
    {
        // validation for constraint: array
        if ('' !== ($consignmentTemplateArrayErrorMessage = self::validateConsignmentTemplateForArrayConstraintsFromSetConsignmentTemplate($consignmentTemplate))) {
            throw new \InvalidArgumentException($consignmentTemplateArrayErrorMessage, __LINE__);
        }
        if (is_null($consignmentTemplate) || (is_array($consignmentTemplate) && empty($consignmentTemplate))) {
            unset($this->consignmentTemplate);
        } else {
            $this->consignmentTemplate = $consignmentTemplate;
        }
        return $this;
    }
    /**
     * Add item to consignmentTemplate value
     * @throws \InvalidArgumentException
     * @param \App\Lib\Unifaun\StructType\ConsignmentTemplate $item
     * @return \App\Lib\Unifaun\StructType\ConsignmentTemplatesResult
     */
    public function addToConsignmentTemplate(\App\Lib\Unifaun\StructType\ConsignmentTemplate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Lib\Unifaun\StructType\ConsignmentTemplate) {
            throw new \InvalidArgumentException(sprintf('The consignmentTemplate property can only contain items of type \App\Lib\Unifaun\StructType\ConsignmentTemplate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->consignmentTemplate[] = $item;
        return $this;
    }
    /**
     * Get errors value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App\Lib\Unifaun\StructType\Error[]|null
     */
    public function getErrors()
    {
        return isset($this->errors) ? $this->errors : null;
    }
    /**
     * This method is responsible for validating the values passed to the setErrors method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErrors method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErrorsForArrayConstraintsFromSetErrors(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $consignmentTemplatesResultErrorsItem) {
            // validation for constraint: itemType
            if (!$consignmentTemplatesResultErrorsItem instanceof \App\Lib\Unifaun\StructType\Error) {
                $invalidValues[] = is_object($consignmentTemplatesResultErrorsItem) ? get_class($consignmentTemplatesResultErrorsItem) : sprintf('%s(%s)', gettype($consignmentTemplatesResultErrorsItem), var_export($consignmentTemplatesResultErrorsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The errors property can only contain items of type \App\Lib\Unifaun\StructType\Error, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set errors value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App\Lib\Unifaun\StructType\Error[] $errors
     * @return \App\Lib\Unifaun\StructType\ConsignmentTemplatesResult
     */
    public function setErrors(array $errors = array())
    {
        // validation for constraint: array
        if ('' !== ($errorsArrayErrorMessage = self::validateErrorsForArrayConstraintsFromSetErrors($errors))) {
            throw new \InvalidArgumentException($errorsArrayErrorMessage, __LINE__);
        }
        if (is_null($errors) || (is_array($errors) && empty($errors))) {
            unset($this->errors);
        } else {
            $this->errors = $errors;
        }
        return $this;
    }
    /**
     * Add item to errors value
     * @throws \InvalidArgumentException
     * @param \App\Lib\Unifaun\StructType\Error $item
     * @return \App\Lib\Unifaun\StructType\ConsignmentTemplatesResult
     */
    public function addToErrors(\App\Lib\Unifaun\StructType\Error $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Lib\Unifaun\StructType\Error) {
            throw new \InvalidArgumentException(sprintf('The errors property can only contain items of type \App\Lib\Unifaun\StructType\Error, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->errors[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Lib\Unifaun\StructType\ConsignmentTemplatesResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
